      SUBROUTINE NLEVSD (X, Y, PRM, XP, NDE, NBCL, NPAR, NNOD, HX, W, U,
     1                  V, YO, RHSU, RHSV, INTEGS, TIMES, NITEM, ITER, 
     2                  EPS, FUN, DFUN, BCOND, DBCOND, PCOND, DPCOND, 
     2                  DETAILS, IFAIL)
C ------------------------------------------------
C     THIS VERSION DATED 12. 09. 2000 /SOFIA/
C     THIS VERSION DATED 16. 10. 2002 /DUBNA/
C     .. 
C     ..     NDE  :
C     .. 
C     .. F_i(X, Y, DY/DX, P) = 0, I = 1,2, ..., NDE
C     .. 
C     ..  NDE  :
C     .. 
C     .. GL_k(Y(A)) = 0,   K = 1, 2, ..., NBCL .LT. NDE
C     .. GR_l(Y(B)) = 0.   L = NBCL+1, ..., NBCR
C     .. 
C     ..    NPAR  P,
C     ..    NPAR  :
C     .. 
C     .. H_J(Y,P) = 0, J = 1,2, ..., NPAR
C     .. 
C     ..   X     Y
C     ..      ..
C     .. 
C     .. TIMES    -   TCOLD ..
C     .. NDE      -   ..
C     .. NNOD     -    ..
C     .. NBCL     -     ..
C     .. NBLOKS   -     W = NNOD-1 ..
C     .. NCOLS    -     W = 4 * NDE
C     .. NITEM    -    ..
C     .. DETAILS  -   = IPRINT ..
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NpM    !    ..
      PARAMETER (NpM = 8)
      INTEGER NDEM   !    ..
      PARAMETER (NDEM = 32)
C     ..      ..
C     ..  DGY = DGm/DYn -    !!!
      INTEGER LWRK, NDE, NBCL, NPAR, NNOD, DETAILS, IFAIL, TIMES, I, K
      PARAMETER (LWRK = 4*NDEM+3*NDEM**2+NPM+NPM**2+2*NPM*NDEM)
      DOUBLE PRECISION WRK(LWRK)
C     .. 
      INTEGER NBLOKS, NCOLS, NROW
      INTEGER NITEM, ITER, IERR
C     .. INPUT ARRAYS ..
      DOUBLE PRECISION XP, X(NNOD)   !  ( ,  ) ..
      DOUBLE PRECISION HX(NNOD-1)    !     ..
C     .. WORKING ARRAYS ..
      DOUBLE PRECISION W(8*NNOD*NDE**2) !        ..
      INTEGER INTEGS(2*NNOD-2)       ! ,    W ..
      DOUBLE PRECISION YO(2*NDE*NNOD) !     ..
C     ..   (INCREMENTS)   ..
      DOUBLE PRECISION U(2*NDE*NNOD)         !   ..
      DOUBLE PRECISION V(2*NDE*NNOD,NPAR)    !   ..
C     ..        ..
      DOUBLE PRECISION RHSU(2*NDE*NNOD)      !   ..
      DOUBLE PRECISION RHSV(2*NDE*NNOD*NPAR) !   ..
C     .. OUTPUT ..
      DOUBLE PRECISION Y(2*NDE*NNOD) !  Y(X) ..
      DOUBLE PRECISION PRM(NPAR)     !    ..
C     ..   ..
      DOUBLE PRECISION DPRM(NpM)     !    ..
      DOUBLE PRECISION DELTA, DELTA0, DELTA1, TAU
      DOUBLE PRECISION EPS           !   ..
C     ..     ..
      INTEGER IEF, IS, IA, IB, IP, IG, IDGY, IDGP, LAST, IH, IDHY, IDHP
C     .. 
      INTRINSIC MIN
C     ..   ..
      EXTERNAL FUN, DFUN, BCOND, DBCOND, PCOND, DPCOND
C ------------------------------------------------
      IFAIL = 0
      NBLOKS = NNOD - 1 !     W ..
C     .. TEMPORARY CHECKS ..
      IF (DETAILS .GT. 1) THEN
         IF (2*NDE*NNOD .NE. NROW) THEN
            IFAIL = 7
CCC         WRITE(*,1020) IFAIL
            GOTO 128
         END IF
      END IF
C     ..
      IF (TIMES .LT. 0) THEN
         IFAIL = 4
         RETURN
      ELSE IF (TIMES .EQ. 0) THEN
         TIMES = 1
C     ..   ..
         IF (NPAR .GT. NpM) THEN
            IFAIL = 1
            RETURN
         ELSE IF (NDE .GT. NDEM) THEN
            IFAIL = 2
            RETURN
         ELSE IF (NBCL .GT. NDE) THEN
            IFAIL = 3
            RETURN
         END IF
C     ..        ..
         IEF = 1                 !      F ..
         IS = IEF + NDE          !     S   ..
         IA = IS + 2 * NDE       !     A ..
         IB = IA + NDE * NDE     !     B ..
         IP = IB + NDE * NDE     !     P ..
         IG = IB + NDE * NPAR    !     G ..
         IDGY = IG + NDE         !     DGY ..
         IDGP = IG + NDE * NDE   !     DGP = DGm/DPk ..
         IH = IDGP + NDE * NPAR     !     H ..
         IDHY = IH + NPAR           !     DHY ..
         IDHP = IDHY + NPAR * NDE   !     DHP ..
         LAST = IDHP + NPAR * NPAR  !       WRK ..
         IF (LAST .GT. LWRK) THEN
            IFAIL = 8   
            RETURN
         END IF
C     ..     ..
         CALL SPLCOEFFS ()
C     ..    INTEGS,     W ..
         CALL MAKE_INTEGS (INTEGS, NBLOKS, NCOLS, NDE, NBCL, NROW)
C     .. CHECK ..
         IF (NROW .NE. (2*NDE*NNOD)) THEN
            WRITE(*,990) NROW, 2*NDE*NNOD
            STOP
         END IF
      ELSE
         TIMES = TIMES + 1
      END IF
C     .. 
C     ..   ..
C     .. 
      DO ITER = 1, NITEM   !     ..
C     ..       DELTA0 ..
         CALL RSIDE (RHSU, RHSV, NDE, NPAR, NNOD, NBCL, X, Y, PRM, HX,
     1               BCOND, DBCOND, FUN, DFUN, DELTA0, WRK(IEF), 
     2               WRK(IS), WRK(IA), WRK(IB), WRK(IG), WRK(IDGY), 
     3               WRK(IP), WRK(IDGP))
         IF (DELTA0 .LT. EPS) GOTO 128 ! SUCCESS !
C     .. 
   16    CALL ASSEMBL (W, NROW, NCOLS, X, Y, PRM, HX, NNOD, NDE, NBCL,
     1                 NPAR, DFUN, WRK(IS), WRK(IA), WRK(IB), WRK(IP),
     2                 WRK(IDGY))
C     ..  NPAR+1        ..
C     ..         NPAR = 1 !!!
C     ..  NPAR .GT. 1 CWIDTH2     ,     ..
         CALL CWIDTH2 (W, RHSU, RHSV, NROW, NCOLS, INTEGS, NBLOKS, U,
     1                 U, V, IERR)
C     ..       U & V ..
         IF (IERR .NE. 0) THEN
            IFAIL = 5
            GOTO 128 ! ERROR RETURN ..
         END IF
C     ..     ..
         CALL PINCREMNTS (XP, Y, WRK(IS), U, V, PRM, DPRM, NPAR, NDE, 
     1                    PCOND, DPCOND, WRK(IH), WRK(IDHY), WRK(IDHP),
     2                    WRK(IA), WRK(IEF), IERR)
         IF (IERR .NE. 0) THEN
            IF (DETAILS .GT. 0) WRITE(*,1010) IERR
            IFAIL = 6
            GOTO 128 ! ERROR RETURN .. 
         END IF
C     .. ""  (TAU = 1.0) ..
         DO I = 1, NROW
            YO(I) = Y(I)    !     ..
            DO K = 1, NPAR
               U(I) = U(I) + PRM(K) * V(I,K) !   ..
            END DO
            Y(I) = Y(I) + U(I)
         END DO
C     ..     ..
         CALL RSIDE (RHSU, RHSV, NDE, NPAR, NNOD, NBCL, X, Y, PRM, HX,
     1               BCOND, DBCOND, FUN, DFUN, DELTA1, WRK(IEF), 
     2               WRK(IS), WRK(IA), WRK(IB), WRK(IG), WRK(IDGY), 
     3               WRK(IP), WRK(IDGP))
         IF (DELTA1 .LT. EPS) GOTO 128 ! SUCCESS !
         DELTA = MIN (DELTA0, DELTA1)
C     .. 
         IF (ITER .EQ. NITEM) GOTO 20
C     .. 
C     ..   ..
         TAU = DELTA0 / (DELTA0 + DELTA1)
C     .. CHECKS ..
         IF (TAU .LT. 0.01D0) THEN
            TAU = 0.01D0
         ELSE IF (TAU .GT. 0.9D0) THEN
            DELTA0 = DELTA1
            GOTO 16
         END IF
C     .. CANM -  ..
         DO I = 1, NROW
            Y(I) = YO(I) + TAU * U(I)
         END DO
      END DO
C     .. TOO MANY ITERATIONS ..
   20 ITER = NITEM
      IFAIL = NITEM
      IF (DETAILS .GT. 0) WRITE(*,1000) NITEM, DELTA
C     .. 
  128 RETURN
C     .. 
  990 FORMAT('  *** ERROR: NROW = ',I5/'          MUST BE = ',I5)
 1000 FORMAT('  *** NO CONVERGENCE AFTER ',I3,' ITERATIONS ***'/
     1       '      END VALUE OF DELTA REACHED: ',1PE12.5)
 1010 FORMAT('  *** IN PINCRMNTS: IERR = ',I3)
      END
      SUBROUTINE ASSEMBL (W, NDIM, NCOLS, X, Y, PRM, HX, NNOD, NDE, 
     1                    NBCL, NPAR, DFUN, S, A, B, P, DGY)
C ------------------------------------------------
C     THIS VERSION DATED 10. 09. 2000 /SOFIA/
C     THIS VERSION DATED 26. 09. 2000 /SOFIA/
C     .. 
C     ..      
C     ..    NDE   1-  ..
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NDIM   !     W (  = NROW) ..
      INTEGER NDE    !    I-  ..
      INTEGER NNOD   !     ..
      INTEGER NBCL   !      ..
      INTEGER NPAR   !      ..
      INTEGER MODE   ! = 1   P(M,K); = 2 -    ..
      INTEGER NCOLS  !     W ..
      INTEGER IFAIL  !    ..
C     .. 
      DOUBLE PRECISION X(NNOD), Y(2*NDE,NNOD) !     ..
      DOUBLE PRECISION HX(NNOD-1)   !      ..
      DOUBLE PRECISION PRM(NPAR)    !     ..
      DOUBLE PRECISION W(NDIM,NCOLS)  !      ..
      DOUBLE PRECISION XIJ, K1, K2, K3, K4, T1, T2
      PARAMETER (T1 = 0.211324865405187117745425609749021D0)
      PARAMETER (T2 = 0.788675134594812882254574390250979D0)
C     ..   -   T1 & T2   ..
      DOUBLE PRECISION U, DU
      COMMON /SPLCOEF/ U(4,2), DU(4,2)
      INTEGER J, IR, L, M, N, M1, NBCR, NBLOKS, M2, IB !     ..
C     ..   
      DOUBLE PRECISION S(2*NDE) !        ..
      DOUBLE PRECISION A(NDE,NDE), B(NDE,NDE) ! -     ..
      DOUBLE PRECISION P(NDE,NPAR)  ! -     ..
      DOUBLE PRECISION DGY (NDE,NDE) !  -     Y ..
C     .. 
      EXTERNAL DFUN
C ------------------------------------------------
      IFAIL = 0
      MODE = 2
      M1 = NDE + 1
      M2 = 2 * NDE !      (   )..
C     .. 
      NBLOKS = NNOD - 1 !      =     W ..
C     ..        W ..
      DO N = 1, (NDE+NBCL)
         DO M = 1, NCOLS
            W(N,M) = 0.0D0
         END DO
      END DO
C     ..    NBCL     ( ) ..
      IR = 1   !       W ..
      DO N = 1, NBCL
C     ..  DGY    RSIDE ..
         DO M = 1, NDE  !   NBCL   DGY   ""   W ..
            W(IR,M) = DGY(N,M)  ! , , ""    ..
         END DO
         IR = IR + 1
      END DO
C     ..        2 ..
      XIJ = X(2)
      L = 1
      DO M = 1, M2, 2
         S(L) = Y(M,2)
         S(NDE+L) = Y(M+1,2)
         L = L + 1
      END DO
C     ..   -       ..
      CALL DFUN (XIJ, S, S(M1), PRM, A, B, P, NDE, NPAR, MODE)
C     .. 
      DO N = 1, NDE
         DO M = 1, NDE
            L = M2 + M
            W(IR,L) = B(N,M)
            L = L + NDE
            W(IR,L) = A(N,M)
         END DO
         IR = IR + 1
      END DO
C     .. 
      DO IB = 1, NBLOKS ! MAIN    ..
         J = 1
C     ..      IB ..
         XIJ = X(IB) + T1 !       .. 
C     .. -       ..
         N = 1
         DO M = 1, M2, 2
C     ..    ..
            S(N) = U(1,J) * Y(M,IB) + U(3,J) * Y(M,IB+1) +
     1             HX(IB) * (U(2,J) * Y(M+1,IB) + U(4,J) * Y(M+1,IB+1))
C     ..    ..
            S(NDE+N) = (DU(1,J) * Y(M,IB) + 
     1                  DU(3,J) * Y(M,IB+1)) / HX(IB) +
     1                  DU(2,J) * Y(M+1,IB) + DU(4,J) * Y(M+1,IB+1)
            N = N + 1
         END DO
C     .. -    1   IB ..
         CALL DFUN (XIJ, S, S(M1), PRM, A, B, P, NDE, NPAR, MODE)
C     ..  ..
         DO N = 1, NDE
            DO M = 1, NDE
               K1 = DU(1,J) * A(N,M) / HX(IB) + U(1,J) * B(N,M)
               K2 = DU(2,J) * A(N,M) + HX(IB) * U(2,J) * B(N,M)
               K3 = DU(3,J) * A(N,M) / HX(IB) + U(3,J) * B(N,M)
               K4 = DU(4,J) * A(N,M) + HX(IB) * U(4,J) * B(N,M)
C     .. 
               L = M    !  ,  ,    - ..
               W(IR,M)  = K1  
               L = L + NDE
               W(IR,L)  = K2
               L = L + NDE
               W(IR,L)  = K3
               L = L + NDE
               W(IR,L)  = K4
            END DO
            IR = IR + 1
         END DO
C     .. 
         J = 1
C     ..      IB ..
         XIJ = X(IB) + T1 !       .. 
C     .. -       ..
         L = 1
         DO M = 1, M2, 2
C     ..    ..
            S(L) = U(1,J) * Y(M,IB) + U(3,J) * Y(M,IB+1) +
     1             HX(IB) * (U(2,J) * Y(M+1,IB) + U(4,J) * Y(M+1,IB+1))
C     ..    ..
            S(NDE+L) = (DU(1,J) * Y(M,IB) + 
     1                  DU(3,J) * Y(M,IB+1)) / HX(IB) +
     2                  DU(2,J) * Y(M+1,IB) + DU(4,J) * Y(M+1,IB+1)
		   L = L + 1
         END DO
C     .. -    1   IB ..
         CALL DFUN (XIJ, S, S(M1), PRM, A, B, P, NDE, NPAR, MODE)
C     ..  ..
         DO N = 1, NDE
            DO M = 1, NDE
               K1 = DU(1,J) * A(N,M) / HX(IB) + U(1,J) * B(N,M)
               K2 = DU(2,J) * A(N,M) + HX(IB) * U(2,J) * B(N,M)
               K3 = DU(3,J) * A(N,M) / HX(IB) + U(3,J) * B(N,M)
               K3 = DU(3,J) * A(N,M) + HX(IB) * U(4,J) * B(N,M)
C     .. 
               L = M
               W(IR,M)  = K1  
               L = L + NDE
               W(IR,L)  = K2
               L = L + NDE
               W(IR,L)  = K3
               L = L + NDE
               W(IR,L)  = K4
            END DO
            IR = IR + 1
         END DO
C     .. 
         J = 2
C     ..      IB ..
         XIJ = X(IB) + T2 !       .. 
C     .. -       ..
	    N = 1 
         DO M = 1, M2, 2
C     ..    ..
            S(N) = U(1,J) * Y(M,IB) + U(3,J) * Y(M,IB+1) +
     1             HX(IB) * (U(2,J) * Y(M+1,IB) + U(4,J) * Y(M+1,IB+1))
C     ..    ..
            S(NDE+N) = (DU(1,J) * Y(M,IB) +
     1                  DU(3,J) * Y(M,IB+1)) / HX(IB) +
     2                  DU(2,J) * Y(M+1,IB) + DU(4,J) * Y(M+1,IB+1)
		   N = N + 1
         END DO
C     .. -    1   IB ..
         CALL DFUN (XIJ, S, S(NDE+1), PRM, A, B, P, NDE, NPAR, MODE)
C     ..  ..
         DO N = 1, NDE
            DO M = 1, NDE
               K1 = DU(1,J) * A(N,M) / HX(IB) + U(1,J) * B(N,M)
               K2 = DU(2,J) * A(N,M) + HX(IB) * U(2,J) * B(N,M)
               K3 = DU(3,J) * A(N,M) / HX(IB) + U(3,J) * B(N,M)
               K3 = DU(3,J) * A(N,M) + HX(IB) * U(4,J) * B(N,M)
C     .. 
               L = M
               W(IR,M)  = K1  
               L = L + NDE
               W(IR,L)  = K2
               L = L + NDE
               W(IR,L)  = K3
               L = L + NDE
               W(IR,L)  = K4
            END DO
            IR = IR + 1
         END DO
      END DO
C     ..      .. 
      NBCR = NDE - NBCL
      M = IR
      DO L = 1, NBCR       !   NBCR   W ..
         DO N = 1, NCOLS
            W(M,N) = 0.0D0
         END DO
         M = M + 1
      END DO
C     ..   NBCR   DGY  3- ""  ..
      DO L = 1, NBCR
         DO M = 1, NDE
            W(IR,2*NDE+M) = DGY(NBCL+L,M)
         END DO
         IR = IR + 1
      END DO
C     .. 
      END
      SUBROUTINE RSIDE (RHSU, RHSV, NDE, NPAR, NNOD, NBCL, X, Y, PRM, 
     1                  HX, BCOND, DBCOND, FUN, DFUN, DELTA, F, S, A, 
     2                  B, G, DGY, P, DGP)
C ------------------------------------------------
C     THIS VERSION DATED 19. 09. 2000 /SOFIA/
C     THIS VERSION DATED 26. 09. 2000 /SOFIA/
C     .. 
C     ..      ,    ..
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NDE, NPAR, NNOD, NBCL, MODE
      DOUBLE PRECISION RHSU(2*NDE*NNOD), RHSV(2*NDE*NNOD,NPAR) 
      DOUBLE PRECISION X(NNOD), Y(2*NDE,NNOD), HX(NNOD-1)
      DOUBLE PRECISION PRM(NPAR) !     ..
C     .. DGY -   -    ..
C     ..          -  ..
      DOUBLE PRECISION DGY(NDE,NDE), F(NDE), A(NDE,NDE), B(NDE,NDE), 
     1                 P(NDE,NPAR), G(NDE), DGP(NDE,NPAR)
C     .. A(M,N) = DFm/DDYn, B(M,N) = DFm/DYn, P(M,K) = DFm/DPk
      DOUBLE PRECISION S(2*NDE)  !      ..
      DOUBLE PRECISION T1, T2
      PARAMETER (T1 = 0.211324865405187117745425609749021D0,
     1           T2 = 0.788675134594812882254574390250979D0)
C     ..   -     ..
      DOUBLE PRECISION U, DU
      COMMON /SPLCOEF/ U(4,2), DU(4,2)
      INTEGER NBLOKS, K, M, M1, M2, IR, IB
      DOUBLE PRECISION DELTA, XIJ
      EXTERNAL FUN, DFUN, BCOND, DBCOND
C ------------------------------------------------
      MODE = 1
      NBLOKS = NNOD - 1
      M1 = NDE + 1
      M2 = 2 * NDE
C     ..  NDE   ..
      K = 1
      DO M = 1, M2, 2
         S(K) = Y(M,1)        !      ..
         S(NDE+K) = Y(M,NNOD) !      ..
         K = K + 1
      END DO
      CALL BCOND (S, S(M1), PRM, G, NDE, NPAR) !   G       ..
C     ..  -    ..
      CALL DBCOND (S, S(M1), PRM, DGY, DGP, NDE, NPAR)
C     .. 
      DELTA = 0.0D0
      DO M = 1, NBCL   !     ..
         RHSU(M) = -G(M)
         DO K = 1, NPAR
            RHSV(M,K) = DGP(M,K)
         END DO
         DELTA = DELTA + G(M) ** 2
      END DO
C     ..       2 ..
C     ..          XADD ..!!!
C     ..         2    F..
      K = 1
      DO M = 1, M2, 2
C     ..     Y   2 ..
         S(K) = Y(M,2)        ! S      ..
C     ..     DY/DX   2 ..
         S(NDE+K) = Y(M+1,2)  ! S      ..
         K = K + 1
      END DO
      CALL FUN (X(2), S, S(NDE+1), PRM, F, NDE, NPAR)
      CALL DFUN (X(2), S, S(NDE+1), PRM, A, B, P, NDE, NPAR, MODE)
C     .. 
      IR = NBCL + 1  !    ..
      DO M = 1, NDE
         RHSU(IR) = -F(M)
         DO K = 1, NPAR
            RHSV(IR,K) = -P(M,K)
         END DO
         IR = IR + 1
      END DO
C     ..    ( ) ..
      DO IB = 1, NBLOKS
C     ..       ..
         XIJ = X(IB) + T1 * HX(IB)
C     .. -       ..
         K = 1
         DO M = 1, M2, 2
C     ..    ..
            S(K) = U(1,1) * Y(M,IB) + U(3,1) * Y(M,IB+1) +
     1             HX(IB) * (U(2,1) * Y(M+1,IB) + U(4,1) * Y(M+1,IB+1))
C     ..    ..
            S(NDE+K) = (DU(1,1) * Y(M,IB) + 
     1                  DU(3,1) * Y(M,IB+1)) / HX(IB) +
     1                  DU(2,1) * Y(M+1,IB) + DU(4,1) * Y(M+1,IB+1)
            K = K + 1
         END DO
C     ..      1   IB ..
         CALL FUN (XIJ, S, S(M1), PRM, F, NDE, NPAR)
C     .. -    1 ..
         CALL DFUN (XIJ, S, S(M1), PRM, A, B, P, NDE, NPAR, MODE)
C     .. ""   ,      ..
         DO M = 1, NDE
            DELTA = DELTA + F(M) ** 2
            RHSU(IR) = -F(M)
            DO K = 1, NPAR
               RHSV(IR,K) = -P(M,K)
            END DO
            IR = IR + 1
         END DO
C     ..       ..
         XIJ = X(IB) + T2 * HX(IB)
C     .. -      ..
         K = 1
         DO M = 1, M2, 2
C     ..   ..
            S(K) = U(1,1) * Y(M,IB) + U(3,1) * Y(M,IB+1) +
     1             HX(IB) * (U(2,1) * Y(M+1,IB) + U(4,1) * Y(M+1,IB+1))
C     ..   ..
            S(NDE+K) = (DU(1,1) * Y(M,IB) + 
     1                  DU(3,1) * Y(M,IB+1)) / HX(IB) +
     1                  DU(2,1) * Y(M+1,IB) + DU(4,1) * Y(M+1,IB+1)
            K = K + 1
         END DO
C     ..      2   IB ..
         CALL FUN (XIJ, S, S(M1), PRM, F, NDE, NPAR)
C     .. -    2 ..
         CALL DFUN (XIJ, S, S(M1), PRM, A, B, P, NDE, NPAR, MODE)
C     .. ""   ,      ..
         DO M = 1, NDE
            DELTA = DELTA + F(M) ** 2
            RHSU(IR) = -F(M)
            DO K = 1, NPAR
               RHSV(IR,K) = -P(M,K)
            END DO
            IR = IR + 1
         END DO
      END DO
C     ..     ..
      DO M = 1, (NDE-NBCL)
         RHSU(IR) = -G(NBCL+M)
         DELTA = DELTA + RHSU(IR) ** 2
         DO K = 1, NPAR
            RHSV(IR,K) = -DGP(NBCL+M,K)
         END DO
      END DO
C     .. 
      RETURN
      END
      SUBROUTINE SPLCOEFFS ()
C ------------------------------------------------
C     ..
C     THIS VERSION DATED 1994. 08. 27 /SOFIA/
C     THIS VERSION DATED 21. 09. 2000 /SOFIA/
C     ..
      IMPLICIT NONE
      DOUBLE PRECISION Fi, DFI
      COMMON /SPLCOEF/ Fi(4,2), DFI(4,2)
C ------------------------------------------------
      Fi(1,1) =  0.88490017945975050967276585366797D0
      Fi(1,2) =  0.11509982054024949032723414633202D0
      Fi(2,1) =  0.13144585576580214704242906504183D0
      Fi(2,2) =  0.03522081090086451962423760162483D0
      Fi(3,1) =  0.11509982054024949032723414633202D0
      Fi(3,2) =  0.88490017945975050967276585366797D0
      Fi(4,1) = -0.03522081090086451962423760162483D0
      Fi(4,2) = -0.13144585576580214704242906504183D0
C     ..
      DFi(1,1) = -1.0D0
      DFi(1,2) = -1.0D0
      DFi(2,1) =  0.28867513459481288225457439025101D0
      DFi(2,2) = -0.28867513459481288225457439025097D0
      DFI(3,1) =  1.0D0
      DFI(3,2) =  1.0D0
      DFI(4,1) = -0.28867513459481288225457439025097D0
      DFI(4,2) =  0.28867513459481288225457439025101D0
C     .. 
      RETURN
      END
      SUBROUTINE CWIDTH2 (W, B1, B2, NROW, NCOLS, INTEGS, NBLOKS, D,
     1                    X1, X2, IFAIL)
C -------------------------------------
C     ..  -      ..
C
C     THIS VERSION DATED 1989. 07. 27 /DUBNA/
C     THIS VERSION DATED 1995. 04. 24 /SOFIA/
C     THIS VERSION DATED 09. 03. 1999 /SOFIA/
C     THIS VERSION DATED 21. 09. 2000 /SOFIA/
C
C          /
C -------------------------------------
C W(NROW,NBLOKS) -  ,    
C         -   A .
C
C NROW -        A.
C
C NBLOKS -   .
C
C NCOLS -    :
C           ,    
C       .
C
C INTEGS(2,NBLOKS) - ,     A:
C     INTEGS (1,I) -     I -  ;
C     INTEGS (2,I) -     I -     A,
C        1 -    (I+1) -   ,
C  T..,  LASTI = INTEGS(2,I)   I -  
C     (I+1) -  .
C      INTEGS(2,NBLOKS) = NCOLS
C
C B1, B2 -  ,       ;
C        .
C
C X1, X2 -      
C D -   (     X)
C
C IPVTEQ -   ,     
C       IPVTEQ+1, IPVTEQ+2,...,LASTEQ,   
C       (  )  
C       IPVTEQ
C -------------------------------------
      IMPLICIT NONE
      INTEGER NCOLS, NROW, NBLOKS
C     .. ARRAYS ARGUMENTS ..
      INTEGER INTEGS(2,NBLOKS)
      DOUBLE PRECISION W(NROW,NCOLS), B1(NROW), B2(NROW)
C     .. OUTPUT ARRAYS ..
      DOUBLE PRECISION X1(NROW), X2(NROW)
C     .. WORKING ARRAYS ..
      DOUBLE PRECISION D(NROW)
      INTEGER IFAIL, I, II, ICOUNT, IPVTEQ, LASTCL,
     1        ISTAR, J, LASTEQ, LASTI, NEXTEQ, NROWAD, JMAX, IERR
      DOUBLE PRECISION AWI1OD, COLMAX, ROWMAX, TEMP, SUM1, SUM2, FACTOR
      DOUBLE PRECISION ZERO, EPS
      PARAMETER (ZERO = 0.0D0, EPS = 0.222044604925031308D-14)
      INTRINSIC ABS, MAX
C -------------------------------------
      IFAIL = 0
      IPVTEQ = 0
      LASTEQ = 0
      DO 50 I = 1, NBLOKS
         NROWAD = INTEGS(1,I)
         DO 10 ICOUNT = 1, NROWAD
            NEXTEQ = LASTEQ + ICOUNT
            ROWMAX = ABS(W(NEXTEQ,1))
            DO J = 2, NCOLS
               ROWMAX = MAX (ROWMAX, ABS(W(NEXTEQ,J)))
            END DO
            IERR = 1
            IF (ROWMAX .LT. EPS) GOTO 9005
            D(NEXTEQ) = ROWMAX
   10    CONTINUE
         LASTEQ = LASTEQ + NROWAD
C     ..
         LASTCL = NCOLS
         LASTI = INTEGS(2,I)
         DO 30 ICOUNT = 1, LASTI
            IPVTEQ = IPVTEQ + 1
            IF (IPVTEQ .LT. LASTEQ)  GO TO 11
            IF ((ABS(W(IPVTEQ,1)) + D(IPVTEQ)). GT. D(IPVTEQ))
     1           GOTO 50
            IERR = 2
            GO TO 9005
C     ..
   11       COLMAX = ABS(W(IPVTEQ,1)) / D(IPVTEQ)
            ISTAR = IPVTEQ
            DO II = (IPVTEQ+1), LASTEQ
               AWI1OD = ABS(W(II,1)) / D(II)
               IF (AWI1OD .GT. COLMAX)  THEN
                  COLMAX = AWI1OD
                  ISTAR = II
               END IF
            END DO
            IERR = 3
            IF ((ABS(W(ISTAR,1)) + D(ISTAR)) .EQ. D(ISTAR))
     1                                    GO TO 9005
            IF (ISTAR .EQ. IPVTEQ)   GOTO 16
            TEMP = D(ISTAR)
            D(ISTAR) = D(IPVTEQ)
            D(IPVTEQ) = TEMP
C     ..
            TEMP = B1(ISTAR)
            B1(ISTAR) = B1(IPVTEQ)
            B1(IPVTEQ) = TEMP
C     ..
            TEMP = B2(ISTAR)
            B2(ISTAR) = B2(IPVTEQ)
            B2(IPVTEQ) = TEMP
C     ..
            DO J = 1, LASTCL
               TEMP = W(ISTAR,J)
               W(ISTAR,J) = W(IPVTEQ,J)
               W(IPVTEQ,J) = TEMP
            END DO
C     ..
   16       DO 20 II = (IPVTEQ+1), LASTEQ
               FACTOR = W(II,1) / W(IPVTEQ,1)
               DO J = 2, LASTCL
                  W(II,J-1) = W(II,J) - FACTOR * W(IPVTEQ,J)
               END DO
               W(II,LASTCL) = ZERO
               B1(II) = B1(II) - FACTOR * B1(IPVTEQ)
               B2(II) = B2(II) - FACTOR * B2(IPVTEQ)
   20       CONTINUE
            LASTCL = LASTCL - 1
   30    CONTINUE
   50 CONTINUE
C     .. END OF DECOMPOSITION LOOP ..
C     .. BACK SUBSTITUTION ..
      DO 80 I = NBLOKS, 1, (-1)
         LASTI = INTEGS(2,I)
         JMAX = NCOLS - LASTI
         DO 70 ICOUNT = 1, LASTI
            SUM1 = ZERO
            SUM2 = ZERO
            DO J = 1, JMAX
               SUM1 = SUM1 + X1(IPVTEQ+J) * W(IPVTEQ,J+1)
               SUM2 = SUM2 + X2(IPVTEQ+J) * W(IPVTEQ,J+1)
            END DO
            X1(IPVTEQ) = (B1(IPVTEQ) - SUM1) / W(IPVTEQ,1)
            X2(IPVTEQ) = (B2(IPVTEQ) - SUM2) / W(IPVTEQ,1)
            JMAX = JMAX + 1
            IPVTEQ = IPVTEQ - 1
   70    CONTINUE
   80 CONTINUE
 9000 RETURN
C     .. ERROR RETURN ..
 9005 CONTINUE
      PRINT 1000, IERR
      IF (IERR .EQ. 1) THEN
         PRINT 1010, I, ICOUNT
CCC      PRINT 1020, (W(I,J), J = 1, NCols)
      ELSE IF (IERR .EQ. 3) THEN
         PRINT 1030, I, IPVTEQ, W(IPVTEQ,1), D(IPVTEQ)
      END IF
      IFAIL = IERR
      RETURN
 1000 FORMAT('*** Error in CWIDTH ***'/'    IFAIL =',I2)
 1010 FORMAT('    Block ',I4, ', Row ',I2)
 1020 FORMAT(4(1X,G14.5))
 1030 FORMAT('    Block ',I4, ', IP ',I3/
     1       '    W(IP,1) = ',1PE12.5,', D(IP) = ',E12.5)
      END
      SUBROUTINE MAKE_INTEGS (INTEGS, NBLOKS, NCOLS, NDE, NBCL, NROW)
C ------------------------------------------------
C     THIS VERSION DATED 10. 09. 2000 /SOFIA/
C     THIS VERSION DATED 20. 09. 2000 /SOFIA/
C     .. 
C     INTEGS(1,I) -     I -     W;
C     INTEGS(2,I) -     I -     W,
C        1 -    (I+1) -  .
C     .. NDE        -    I-  ..
C     .. NBCL     -     ..
C     .. NBLOKS   -     W = NNOD-1 ..
C     .. NCOLS    -     W = 4 * NDE
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NDE, NBCL, NBLOKS, NROW, NCOLS, I, M2
      INTEGER INTEGS(2,NBLOKS)
C ------------------------------------------------
      M2 = 2 * NDE !     ..
      NCOLS = 4 * M2  !     
C     ..    NBCL + 2*NDE  ..
      INTEGS(1,1) = NBCL + M2 + NDE
      INTEGS(2,1) = M2
      NROW = INTEGS(1,1)      !      W ..
      DO I = 2, (NBLOKS-1)
         INTEGS(1,I) = M2
         INTEGS(2,I) = M2
         NROW = NROW + INTEGS(1,I)
      END DO
      INTEGS(1,NBLOKS) = M2 + (M2 - NBCL) !         ..
      INTEGS(2,NBLOKS) = NCOLS
      NROW = NROW + INTEGS(1,NBLOKS)
C     .. 
      RETURN
      END
      SUBROUTINE DECOMP (A, NDIM, N, IPVT, IFAIL)
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NDIM, N, IFAIL, IPVT(N), I, J, K, INTR
      DOUBLE PRECISION A(NDIM,N), EPS, TEMP, AMAX
      PARAMETER (EPS = 2.220446D-14)
      INTRINSIC ABS
C ------------------------------------------------
C     .. /  L-U    A     ..
C     ..
C     THIS VERSION DATED 25. 09. 1999 /SOFIA/
C     THIS VERSION DATED 19. 09. 2000 /SOFIA/
C     REVISED BY TODOR BOYADJIEV
C ------------------------------------------------
      IFAIL = 0
      IF (N .EQ. 1) THEN   !   ""  1  ..
         IF (ABS(A(1,1)) .LT. EPS) GOTO 137
         RETURN
      END IF
C     .. 
      DO K = 1, N
         IF (K .EQ. 1) GO TO 20
         DO I = K, N
            TEMP = A(I,K)
            DO J = 1, (K-1)
               TEMP = TEMP - A(I,J) * A(J,K)
            END DO
            A(I,K) = TEMP
         END DO
         IF (K .EQ. N) GOTO 100
C     ..
   20    AMAX = ABS (A(K,K))
         INTR = K
         DO I = (K+1), N
            TEMP = ABS (A(I,K))
            IF (TEMP .GT. AMAX) THEN
               AMAX = TEMP
               INTR = I
            END IF
         END DO
C     ..      ..
         IF (AMAX .LT. EPS) GO TO 137
         IPVT(K) = INTR
         IF (INTR. EQ. K) GO TO 50
C     ..  ..
         DO J = 1, N
            TEMP = A(K,J)
            A(K,J) = A(INTR,J)
            A(INTR,J) = TEMP
         END DO
C     ..
   50    DO J = (K+1), N
            TEMP = A(K,J)
            DO I = 1, (K-1)
               TEMP = TEMP - A(K,I) * A(I,J)
            END DO
            A(K,J) = TEMP / A(K,K)
         END DO
      END DO
  100 RETURN
C     ..
  137 IFAIL = 137
      RETURN
      END
      SUBROUTINE SOLVE (A, NDIM, N, IPVT, B)
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NDIM, N, IPVT(N), I, J, K
      DOUBLE PRECISION A(NDIM,N), B(N), TEMP
C     ..
C     .. /   A * X = B ..
C        / DECOMP
C        X(N),
C           B(N) ..
C     ..
C     THIS VERSION DATED 14. 09. 1999 /SOFIA/
C     THIS VERSION DATED 19. 10. 1999 /SOFIA/
C     REVISED BY TODOR BOYADJIEV
C ------------------------------------------------
      IF (N .EQ. 1) THEN   !   ""  1  ..
         B(1) = B(1) / A(1,1)
         RETURN 
      END IF
C     .. 
      DO J = 1, (N-1)
         I = IPVT(J)
         IF (I .NE. J) THEN
            TEMP = B(J)
            B(J) = B(I)
            B(I) = TEMP
         END IF
      END DO
C     ..    L * Y = B ..
      B(1) = B(1) / A(1,1)
C     .. 
      DO I = 2, N
         TEMP = B(I)
         DO J = 1, (I-1)
            TEMP = TEMP - A(I,J) * B(J)
         END DO
         B(I) = TEMP / A(I,I)
      END DO
C     ..    U * X = Y ..
      DO K = 1, (N-1)
         I = N - K
         TEMP = B(I)
         DO J = (I+1), N
            TEMP = TEMP - A(I,J) * B(J)
         END DO
         B(I) = TEMP
      END DO
C     ..
      RETURN
      END
      SUBROUTINE PINCREMNTS (XP, YP, Y, U, V, PRM, DPRM, NPAR, NDE, 
     1                       PCOND, DPCOND, H, DHY, DHP, ALG, IPVT, 
     2                       IFAIL)
C ------------------------------------------------
C     ..     ..
C     ..    -  ! ..
C     ..      (XP, YP),    "" ..
C     .. 
C     THIS VERSION DATED 19. 09. 2000 /SOFIA/
C     THIS VERSION DATED 22. 09. 2000 /SOFIA/
C     THIS VERSION DATED 26. 09. 2000 /SOFIA/
C ------------------------------------------------
      IMPLICIT NONE
      INTEGER NPAR  !    ..
      INTEGER NDE !       ..
C     ..
      INTEGER IFAIL, K, L, M
      DOUBLE PRECISION PRM(NPAR)   !     ..
      DOUBLE PRECISION XP, YP(2*NDE)  !   ""  ..
      DOUBLE PRECISION U(2*NDE), V(2*NDE,NPAR)  !     ""  ..
C     .. OUTPUT ..
      DOUBLE PRECISION H(NPAR), DHY(NPAR,NDE), DHP(NPAR,NPAR)
      DOUBLE PRECISION DPRM(NPAR)  !    ..
C     ..   ..
      INTEGER IPVT(NPAR)
      DOUBLE PRECISION Y(NDE), ALG(NPAR,NPAR) !     .. 
      DOUBLE PRECISION HU, HV
C     .. USER-  ..
      EXTERNAL PCOND, DPCOND
C ------------------------------------------------
      K = 1
      DO M = 1, 2*NDE, 2
         Y(K) = YP(M)
         K = K + 1
      END DO
      CALL PCOND (XP, Y, PRM, H, NDE, NPAR) !   P-  ""  ..
      CALL DPCOND (XP, Y, PRM, DHY, DHP, NDE, NPAR) ! - ..
C     ..           ..
      DO K = 1, NPAR
         HU = 0.0D0
         DO M = 1, NDE, 2  !    U       ..
            HU = DHY(K,M) * U(M)
         END DO
         DPRM(K) = -(H(K) + HU)  !      ..
      END DO
C     ..
      DO K = 1, NPAR
         DO L = 1, NPAR
            HV = 0.0D0
            DO M = 1, NDE, 2
C     ..  M-  V(M,L)   L       ..
               HV = HV + DHY(K,M) * V(M,L)
            END DO
            ALG(K,L) = HV + DHP(K,L)  !     ..
         END DO
      END DO
C     ..     "NPAR"       ..
      IFAIL = 0
      CALL DECOMP (ALG, NPAR, NPAR, IPVT, IFAIL)
      IF (IFAIL .NE. 0) RETURN
C     ..         DPRM ..
      CALL SOLVE (ALG, NPAR, NPAR, IPVT, DPRM)
C     ..       DPRM ..
      RETURN
      END
